/*
                             +---------------+  
                             | ConsList<T>   |  
                             +---------------+  
                        +----| T first       | 
                        |    | AList<T> rest | 
                        |    +---------------+ 
                        |
                       ...
                      /   \
                     /     \
                   ...     ...

              |                  |
              v                  v
	+--------------+    +--------------+
	| Book         |    | Song         |
    +--------------+    +--------------+
    | String title |    | String title | 
	| String author|    | int    time  |
	| int    year  |    +--------------+  
    +--------------+
 */	

//to represent a nonempty list of objects of the type T
class ConsList<T> implements AList<T>{

  T first;
  AList<T> rest;

  ConsList(T first, AList<T> rest){
    this.first=first;
    this.rest=rest;
  }

  //does this non-empty list contain that object   
  public boolean contains(T that){ 
    if (this.first.equals(that))
      return true;
    else 
      return this.rest.contains(that); 
  } 
} 
